#include <iostream>
#include <cstring>
using namespace std;

const int MAXN = 3000006;

int n, a[MAXN], p[MAXN];
long long s_inv[MAXN], b_inv[MAXN];
int tree[MAXN];

void add(int x)
{
    for (int i = x; i < MAXN; i += i & (-i))
    {
        tree[i]++;
    }
}

int get(int x)
{
    int s = 0;
    for (int i = x; i >= 1; i -= i & (-i))
    {
        s += tree[i];
    }
    return s;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    cin >> n;
    for (int i = 1; i <= n; ++ i)
    {
        cin >> a[i];
        p[a[i]] = i;
    }

    long long cnt = 0;
    for (int i = 1; i <= n; ++ i)
    {
        int pos = p[i], val = i;
        s_inv[i] = cnt;
        cnt += get(n + 1 - pos);
        add(n + 1 - pos);
    }

    cnt = 0;
    memset(tree, 0, 4 * MAXN);
    for (int i = n; i >= 1; -- i)
    {
        int pos = p[i], val = i;
        b_inv[i] = cnt;
        cnt += get(pos);
        add(pos);
    }

    long long ans = 5e12;
    for (int i = 1; i <= n; ++ i)
    {
        ans = min(ans, s_inv[i] + b_inv[i]);
    }

    cout << ans << endl;
    return 0;
}
